Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  trait AccessorSynthesis extends SubComponent with Transform with TreeDSL
  Definition Classes
    transform
-  trait CheckedAccessorTreeSynthesis extends AccessorTreeSynthesis
  Definition Classes
    AccessorSynthesis
- SynthCheckedAccessorsTreesInClass
- SynthInitCheckedAccessorsIn
- SynthLazyAccessorsIn
- UncheckedAccessorSynth

c

scala.tools.nsc.transform.AccessorSynthesis.CheckedAccessorTreeSynthesis

# SynthLazyAccessorsIn 

###

#### class SynthLazyAccessorsIn extends SynthCheckedAccessorsTreesInClass

Source
  AccessorSynthesis.scala

Linear Supertypes
SynthCheckedAccessorsTreesInClass, CheckedAccessorSymbolSynth, AnyRef, Any
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. SynthLazyAccessorsIn
2. SynthCheckedAccessorsTreesInClass
3. CheckedAccessorSymbolSynth
4. AnyRef
5. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new SynthLazyAccessorsIn(clazz: Global.Symbol)

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from SynthLazyAccessorsIn to any2stringadd[SynthLazyAccessorsIn] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (SynthLazyAccessorsIn, B)
   Implicit
     This member is added by an implicit conversion from SynthLazyAccessorsIn to ArrowAssoc[SynthLazyAccessorsIn] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def bitmapCategory(sym: Global.Symbol): Global.Name

   Examines the symbol and returns a name indicating what brand of bitmap it requires.

   Examines the symbol and returns a name indicating what brand of bitmap it requires. The possibilities are the BITMAP_* vals defined in StdNames. If it needs no bitmap, nme.NO_NAME.

   bitmaps for checkinit fields are not inherited

   Attributes
     protected
   Definition Classes
     CheckedAccessorSymbolSynth
8.  def bitmapFor(sym: Global.Symbol): BitmapInfo
   Definition Classes
     CheckedAccessorSymbolSynth
9.  val clazz: Global.Symbol
   Attributes
     protected
   Definition Classes
     SynthLazyAccessorsIn → CheckedAccessorSymbolSynth
10.  def clone(): AnyRef
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
11.  def computeBitmapInfos(decls: List[Global.Symbol]): List[Global.Symbol]

    Fill the map from fields to bitmap infos.

    Fill the map from fields to bitmap infos.

    Instead of field symbols, the map keeps their getter symbols. This makes code generation easier later.

    Definition Classes
      CheckedAccessorSymbolSynth
12.  def defaultPos: Position
    Attributes
      protected
    Definition Classes
      CheckedAccessorSymbolSynth
13.  def ensuring(cond: (SynthLazyAccessorsIn) ⇒ Boolean, msg: ⇒ Any): SynthLazyAccessorsIn
    Implicit
      This member is added by an implicit conversion from SynthLazyAccessorsIn to Ensuring[SynthLazyAccessorsIn] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  def ensuring(cond: (SynthLazyAccessorsIn) ⇒ Boolean): SynthLazyAccessorsIn
    Implicit
      This member is added by an implicit conversion from SynthLazyAccessorsIn to Ensuring[SynthLazyAccessorsIn] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  def ensuring(cond: Boolean, msg: ⇒ Any): SynthLazyAccessorsIn
    Implicit
      This member is added by an implicit conversion from SynthLazyAccessorsIn to Ensuring[SynthLazyAccessorsIn] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  def ensuring(cond: Boolean): SynthLazyAccessorsIn
    Implicit
      This member is added by an implicit conversion from SynthLazyAccessorsIn to Ensuring[SynthLazyAccessorsIn] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
17.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
18.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
19.  def expandLazyClassMember(lazyVar: Global.Symbol, lazyAccessor: Global.Symbol, transformedRhs: Global.Tree): Global.Tree

    The compute method (slow path) looks like:

    The compute method (slow path) looks like:

    ```def l$compute() = { synchronized(this) { if ((bitmap$n & MASK) == 0) { init // l$ = <rhs> bitmap$n = bimap$n | MASK } } ... this.f1 = null ... this.fn = null l$ } `````````

    `bitmap$n` is a byte, int or long value acting as a bitmap of initialized values. The kind of the bitmap determines how many bit indicators for lazy vals are stored in it. For Int bitmap it is 32 and then 'n' in the above code is: (offset / 32), the MASK is (1 << (offset % 32)).

    If the class contains only a single lazy val then the bitmap is represented as a Boolean and the condition checking is a simple bool test.

    Private fields used only in this initializer are subsequently set to null.

    For performance reasons the double-checked locking is split into two parts, the first (fast) path checks the bitmap without synchronizing, and if that fails it initializes the lazy val within the synchronization block (slow path).

    This way the inliner should optimize the fast path because the method body is small enough.

20.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
21.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from SynthLazyAccessorsIn to StringFormat[SynthLazyAccessorsIn] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
22.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
23.  def hasBitmap(sym: Global.Symbol): Boolean
    Attributes
      protected
    Definition Classes
      CheckedAccessorSymbolSynth
24.  def hasTransientAnnot(field: Global.Symbol): Boolean
    Attributes
      protected
    Definition Classes
      CheckedAccessorSymbolSynth
25.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
26.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
27.  def isTrait: Boolean
    Attributes
      protected
    Definition Classes
      CheckedAccessorSymbolSynth
28.  def isUnitGetter(sym: Global.Symbol): Boolean
    Definition Classes
      SynthCheckedAccessorsTreesInClass
29.  def mkSetFlag(valSym: Global.Symbol): Global.Tree

    Return an (untyped) tree of the form 'Clazz.this.bmp = Clazz.this.bmp | mask'.

    Return an (untyped) tree of the form 'Clazz.this.bmp = Clazz.this.bmp | mask'.

    Definition Classes
      SynthCheckedAccessorsTreesInClass
30.  def mkTest(field: Global.Symbol, equalToZero: Boolean = true): Global.Tree

    Return an (untyped) tree of the form 'clazz.this.bitmapSym & mask (==|!=) 0', the precise comparison operator depending on the value of 'equalToZero'.

    Return an (untyped) tree of the form 'clazz.this.bitmapSym & mask (==|!=) 0', the precise comparison operator depending on the value of 'equalToZero'.

    Definition Classes
      SynthCheckedAccessorsTreesInClass
31.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
32.  def needsBitmap(sym: Global.Symbol): Boolean
    Definition Classes
      CheckedAccessorSymbolSynth
33.  def newSlowPathSymbol(lzyVal: Global.Symbol): Global.Symbol
    Definition Classes
      CheckedAccessorSymbolSynth
34.  final def notify(): Unit
    Definition Classes
      AnyRef
35.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
36.  def slowPathFor(lzyVal: Global.Symbol): Global.Symbol
    Definition Classes
      CheckedAccessorSymbolSynth
37.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
38.  def thisRef: Global.This
    Definition Classes
      SynthCheckedAccessorsTreesInClass
39.  def toString(): String
    Definition Classes
      AnyRef → Any
40.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
41.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
42.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
43.  def →[B](y: B): (SynthLazyAccessorsIn, B)
    Implicit
      This member is added by an implicit conversion from SynthLazyAccessorsIn to ArrowAssoc[SynthLazyAccessorsIn] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from SynthCheckedAccessorsTreesInClass

### Inherited from CheckedAccessorSymbolSynth

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from SynthLazyAccessorsIn to any2stringadd[SynthLazyAccessorsIn]

### Inherited by implicit conversion StringFormat from SynthLazyAccessorsIn to StringFormat[SynthLazyAccessorsIn]

### Inherited by implicit conversion Ensuring from SynthLazyAccessorsIn to Ensuring[SynthLazyAccessorsIn]

### Inherited by implicit conversion ArrowAssoc from SynthLazyAccessorsIn to ArrowAssoc[SynthLazyAccessorsIn]

### Ungrouped